package com.usky.iot.controller.web;


import com.usky.common.core.bean.ApiResult;
import com.usky.common.core.bean.CommonPage;
import com.usky.iot.domain.BaseAlarm;
import com.usky.iot.domain.BaseGgpFacility;
import com.usky.iot.service.BaseAlarmService;
import com.usky.iot.service.vo.BaseAlarmListVO;
import com.usky.iot.service.vo.BaseAlarmRequestVO;
import com.usky.iot.service.vo.BaseAlarmResponeVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import org.springframework.stereotype.Controller;

/**
 * <p>
 * 统一告警表 前端控制器
 * </p>
 *
 * @author han
 * @since 2023-07-13
 */
@RestController
@RequestMapping("/baseAlarm")
public class BaseAlarmController {
    @Autowired
    private BaseAlarmService baseAlarmService;

    /**
     * 统计
     * @param baseAlarmRequestVO
     * @return
     */
    @PostMapping("/statistic")
    public ApiResult<CommonPage<BaseAlarmResponeVO>> statistic(@RequestBody BaseAlarmRequestVO baseAlarmRequestVO){
        return ApiResult.success(baseAlarmService.statistic(baseAlarmRequestVO));
    }

    /**
     * 分页
     * @param baseAlarmListVO
     * @return
     */
    @PostMapping("/page")
    public ApiResult<CommonPage<BaseAlarm>> page(@RequestBody BaseAlarmListVO baseAlarmListVO){
        return ApiResult.success(baseAlarmService.page(baseAlarmListVO));
    }

    /**
     * 修改
     * @param baseAlarm
     * @return
     */
    @PutMapping
    public ApiResult<Void> update(@RequestBody BaseAlarm baseAlarm){
        baseAlarmService.update(baseAlarm);
        return ApiResult.success();
    }

    /**
     * 新增
     * @param baseAlarm
     * @return
     */
    @PostMapping("/alarmInfo")
    public ApiResult<Void> add(@RequestBody BaseAlarm baseAlarm){
        baseAlarmService.add(baseAlarm);
        return ApiResult.success();
    }
}

