package com.usky.iot.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import java.time.LocalDate;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import java.time.LocalDateTime;
import java.io.Serializable;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 建筑信息
 * </p>
 *
 * @author han
 * @since 2023-06-07
 */
@Data
@EqualsAndHashCode(callSuper = false)
public class BaseBuild implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 主键
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 建筑编号
     */
    private String buildNum;

    /**
     * 建筑名称
     */
    private String buildName;

    /**
     * 详细地址
     */
    private String address;

    /**
     * 模型地址
     */
    private String modelAddress;

    /**
     * 地上楼层
     */
    private Integer aboveFloor;

    /**
     * 地下楼层
     */
    private Integer underFloor;

    /**
     * 建筑面积
     */
    private Double buildArea;

    /**
     * 占地面积
     */
    private Double coverArea;

    /**
     * 耐火等级
     */
    private Integer fireRating;

    /**
     * 使用性质
     */
    private Integer useCharacter;

    /**
     * 建筑结构
     */
    private Integer buildStructure;

    /**
     * 建筑高度
     */
    private Double buildHigh;

    /**
     * 建筑高度分类
     */
    private Integer highType;

    /**
     * 竣工年份
     */
    private LocalDate completeYear;

    /**
     * 安全责任人
     */
    private String safePerson;

    /**
     * 安全管理人
     */
    private String managePerson;

    /**
     * 火灾危险性
     */
    private Integer fireRisk;

    /**
     * 消防控制室位置
     */
    private String fireControlRoom;

    /**
     * 建筑立面图
     */
    private String buildInside;

    /**
     * 建筑平面图
     */
    private String buildPlan;

    /**
     * 设施ID
     */
    private Integer facilityId;

    /**
     * BIM地址
     */
    private String bimUrl;

    /**
     * 联系人电话
     */
    private String contactPhone;

    /**
     * 建筑备注
     */
    private String buildDesc;

    /**
     * 创建时间
     */
    private LocalDateTime createTime;

    /**
     * 更新时间
     */
    private LocalDateTime updateTime;

    /**
     * 更新人
     */
    private String updateBy;

    /**
     * 创建人
     */
    private String createBy;

    /**
     * 删除标识
     */
    private Integer deleteFlag;

    /**
     * 地下空间
     */
    private Double underSpace;

    /**
     * 防火涂层（0、无 1、有）
     */
    private Integer fireproofCoat;

    /**
     * 组织机构ID
     */
    private Integer deptId;

    /**
     * 租户ID
     */
    private Integer tenantId;

    /**
     * 建筑设施总数
     */
    @TableField(exist = false)
    private Integer buildFacilityCount;
}
