package com.usky.iot.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import java.time.LocalDateTime;
import java.io.Serializable;

import com.fasterxml.jackson.annotation.JsonFormat;

import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 建筑设施
 * </p>
 *
 * @author han
 * @since 2023-07-26
 */
@Data
@EqualsAndHashCode(callSuper = false)
public class BaseBuildFacility implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 主键
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 建筑Id
     */
    @TableField(exist = false)
    private Integer buildId;

    /**
     * 建筑名称
     */
    @TableField(exist = false)
    private String buildName;

    /**
     * 设施编号
     */
    private String facilityNum;

    /**
     * 设施名称
     */
    private String facilityName;

    /**
     * 设施类型
     */
    private String facilityType;

    /**
     * 设施类型名称
     */
    @TableField(exist = false)
    private String typeName;

    /**
     * 所属楼层
     */
    private String floor;

    /**
     * 安装位置
     */
    private String address;

    /**
     * 图⽚地址URL
     */
    private String imagesUrl;

    /**
     * 设备ID
     */
    private String deviceId;

    /**
     * 联系人
     */
    private String contact;

    /**
     * 联系方式
     */
    private String contactPhone;

    /**
     * 平面X轴坐标
     */
    private String planeX;

    /**
     * 平面Y轴坐标
     */
    private String planeY;

    /**
     * X轴坐标
     */
    private String coordinateX;

    /**
     * Y轴坐标
     */
    private String coordinateY;

    /**
     * Z轴坐标
     */
    private String coordinateZ;

    /**
     * 删除标识
     */
    private Integer deleteFlag;

    /**
     * 创建时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime createTime;

    /**
     * 更新时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime updateTime;

    /**
     * 更新人
     */
    private String updateBy;

    /**
     * 创建人
     */
    private String createBy;

    /**
     * 组织结构ID
     */
    private Integer deptId;

    /**
     * 租户ID
     */
    private Integer tenantId;

    /**
     * 建筑设施备注
     */
    private String facilityDesc;
}
